/**
 * 
 */
package testaaminen;

/**
 * Kokeillaan testaamista
 * @author vesal
 * @version 27.1.2020
 */
public class Poista {

    /**
     * Poistetaan jonosta kaikki poistettavan esiintymät niin ettei sinne jää niitä yhtään
     * @param jono josta poistetaan
     * @param poistettava mitä poistetaan
     * @return jono jossa ei ole yhtään poistettavaa
     * @example
     * <pre name="test">
     *   poista("Catcat"   ,"at")  =>  "Cc";  // perustapaus
     *   poista("Paatti"   ,"at")  ===  "Pi";  // luo uuden esiintymän
     *   poista("Puatit"   ,"at")  ===  "Puit";
     *   poista("Abba"     ,"bb")  ===  "Aa";
     *   poista("Abbababba","ba")  ===  "Abb";
     *   poista("AbbabaaB" ,"ba")  ===  "AB";
     *   poista("Abba"     ,"Ab")  ===  "ba";
     *   poista("Abba"     ,"cc")  ===  "Abba";
     *   poista("Abba"     ,""  )  ===  "Abba";
     *   poista(""         ,"Aa")  ===  "";
     *   poista(""         ,""  )  ===  "";
     *   poista(null       ,""  )  ===  "";
     *   poista(null       ,"k"  ) ===  "";   //  #THROWS NullPointerException
     *   poista("Kissa"    ,null)  ===  "Kissa";
     * </pre>
     */
    public static String poista(String jono, String poistettava) {
        return demo.d3.Poista.poista(jono, poistettava);
    }
    

    private static int poistatesti(String jono, String poistettava, String odotettuTulos)  {
        String tulos = poista(jono, poistettava);
        if ( tulos.equals(odotettuTulos) ) return 0;
        System.out.println(jono + " => " + tulos + " piti tulla " + odotettuTulos);
        return 1;
    }
    
    
    /**
     * Kokeillaan poista-funktiota
     * @param args ei käytössä
     */
    public static void main(String[] args) {
        int v = 0;
        v += poistatesti("Catcat", "at", "Cc");
        v += poistatesti("Paatti", "at", "Pi");
        v += poistatesti("Paatti", "aa", "Ptti");
        v += poistatesti("Paatti", "P",  "aatti");
        v += poistatesti("Paatti", "",   "Paatti");
        v += poistatesti("Paatti", "kana", "Paatti");
        v += poistatesti("Paatti", "t", "Paai");
        if ( v == 0 ) System.out.println("Kaikki meni läpi");
    }

}
