/**
 * 
 */
package kerho;

/**
 * samoja tekstejä kuin CRC-kortissa
 * @author vesal
 * @version 18.2.2020
 *
 */
public class Kerho {
    
    Jasenet jasenet = new Jasenet();
    // Harrastukset harrastukset = new Harrastukset();
    
    
    /**
     * Alustetaan kerho tiedot
     */
    public Kerho() {
        // ei tartte tehä mittään
    }

    
    /**
     * Liästään uusi jäen kerhoon
     * @param jasen lisättävä
     * @throws SailoException jos ei mahu
     * @example
     * <pre name="test">
     * #THROWS SailoException
     * Kerho kerho = new Kerho();
     * Jasen aku1 = new Jasen(), aku2 = new Jasen();
     * aku1.rekisteroi(); aku2.rekisteroi();
     * kerho.getJasenia() === 0;
     * kerho.lisaa(aku1); kerho.getJasenia() === 1;
     * kerho.lisaa(aku2); kerho.getJasenia() === 2;
     * kerho.lisaa(aku1); kerho.getJasenia() === 3;
     * kerho.annaJasen(0) === aku1;
     * kerho.annaJasen(1) === aku2;
     * kerho.annaJasen(2) === aku1;
     * kerho.annaJasen(3) === aku1; #THROWS IndexOutOfBoundsException 
     * kerho.lisaa(aku1); kerho.getJasenia() === 4;
     * kerho.lisaa(aku1); kerho.getJasenia() === 5;
     * kerho.lisaa(aku1);            #THROWS SailoException
     * </pre>
     */
    public void lisaa(Jasen jasen) throws SailoException {
        jasenet.lisaa(jasen);
    }
    
    
    /**
     * Palautaa kerhon jäsenmäärän
     * @return jäsenmäärä
     */
    public int getJasenia() {
        return jasenet.getLkm();
    }
    
    
    /**
     * Palauttaa i:n jäsenen
     * @param i monesko jäsen palautetaan
     * @return viite i:teen jäseneen
     * @throws IndexOutOfBoundsException jos i väärin
     */
    public Jasen annaJasen(int i) throws IndexOutOfBoundsException {
        return jasenet.anna(i);
    }

    
    
    /**
     * @param args ei käytössä
     */
    public static void main(String[] args) {
        var kerho = new Kerho();
        
        var aku1 = new Jasen();
        var aku2 = new Jasen();
        
        aku1.rekisteroi();
        aku1.vastaaAkuAnkka();
        aku2.rekisteroi();
        aku2.vastaaAkuAnkka();
        
        try {
            kerho.lisaa(aku1);
            kerho.lisaa(aku2);
        } catch (SailoException e) {
            System.err.println(e.getMessage());
            System.err.flush();
        }
 
        System.out.println("============= Kerhon testi =================");

        for (int i = 0; i < kerho.getJasenia(); i++) {
            Jasen jasen = kerho.annaJasen(i);
            System.out.println("Jäsen paikassa: " + i);
            jasen.tulosta(System.out);
        }
    
    }

}
