package taulukot;
import java.io.OutputStream;
import java.io.PrintStream;
/**
 * Tutkitaan Javan taulukkoja
 * @author vesal
 * @version 24.2.2020
 *
 */
public class Kuut {
    /**
     * @param args ei käytössä
     */
    public static void main(String[] args) {  // s = new String("Kissa")
        int[] kPituudet = new int[]{31,28,31,30,31,30,31,31,30,31,30,31};
        int[] kPituudet2 = new int[12];
        System.out.println(jonoksi(kPituudet, " ", 2));
        nollaaTaulukko(kPituudet);
        tulosta(System.out, kPituudet);
        tulosta(System.out, kPituudet2);
    }
    
    /**
     * tyhjennetään taulukko
     * @param t t
     * @return sama talukkoviite 
     */
    public static int[] nollaaTaulukko(int[] t) {
        // for (int alkio: t) 
        //    alkio = 0;
        for (int i = 0; i < t.length; i++) {
            // int alkio = t[i];
            // alkio = 0;
            t[i] = 0;
        }
        return t;
    }
    
    
    /**
     * Tulostetaan taulukon luvut kukin 2 merkin kokoiseen tilaan
     * välilyönnein eroteltuna.  Loppuun jää ylimääräinen välilyönti
     * @param os tietovirta johon tulostetaan
     * @param taulukko tulostettava taulukko
     * @example
     * <pre name="test">
     *  #import java.io.*;
     *   ByteArrayOutputStream bs = new ByteArrayOutputStream();
     *   int[] t = {1,2,13,4};
     *   tulosta(bs,t);
     *   bs.toString() =R= "(?s) 1  2 13  4 .*"; // ?s tekee että \n kelpaa  
     * </pre>
     */
    public static void tulosta(OutputStream os, int taulukko[]) {
        PrintStream out = new PrintStream(os); 
        for (int i = 0; i < taulukko.length; i++)
            out.print(String.format("%2d ",taulukko[i]));
        out.println();
    }
    
    
    
    /**
     * Palautetaan taulukko merkkijonona erottimella eroteltuna.
     * Lopussa ei ylimääräistä erotinta.
     * @param taulukko joka palautetaan jonona
     * @param erotin millä jonolla erotellaan
     * @param tila monenko merkin tila kullekin numerolle varataan.
     * @return taulukko merkkijonona erottimella eroteltuna
     * @example
     * <pre name="test">
     *   int[] t = {1,2,13,4};
     *   jonoksi(t,",",1) === "1,2,13,4";
     *   jonoksi(t,",",2) === " 1, 2,13, 4";
     * </pre>
     */
    public static String jonoksi(int[] taulukko,String erotin,int tila) {
        StringBuilder tulos = new StringBuilder();
        //String format = String.format("%%s%%%dd", tila); // esim. %s%2d
        String format = "%s%" + tila + "d"; // esim. %s%2d
        String ero = "";
        for (int  luku : taulukko) {
            tulos.append(String.format(format,ero,luku));
            ero = erotin;
        }
        return tulos.toString();
    }
}

