package fxAanestysRB;
	
import fi.jyu.mit.fxgui.Dialogs;
import javafx.application.Application;
import javafx.beans.InvalidationListener;
import javafx.collections.ObservableList;
import javafx.geometry.Insets;
import javafx.geometry.Pos;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.RadioButton;
import javafx.scene.control.ScrollPane;
import javafx.scene.control.Toggle;
import javafx.scene.control.ToggleGroup;
import javafx.scene.layout.BorderPane;
import javafx.scene.layout.Pane;
import javafx.scene.layout.VBox;
import javafx.scene.text.Font;
import javafx.stage.Stage;


/**
 * Pääohjelma äänestykselle.  Tehty pelkällä Javalla
 * ja omalla komponentilla.
 * @author vesal
 * @version 6.2.2017
 *
 */
public class AanestysMain3 extends Application {
	@Override
	public void start(Stage primaryStage) {
		try {
			Pane root = luoNaytto();
			Scene scene = new Scene(root);
			// scene.getStylesheets().add(getClass().getResource("aanestys.css").toExternalForm());
			primaryStage.setScene(scene);
			primaryStage.setTitle("Äänestys");
			primaryStage.show();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	
	/**
	 * Käynnistetään äänestys
	 * @param args ei käytössä
	 */
	public static void main(String[] args) {
		launch(args);
	}
	
	
	private Pane luoNaytto() {
	    BorderPane pane = new BorderPane();
	    Label labelAihe = new Label("Onko ohjelmointi kivaa?");
	    BorderPane.setAlignment(labelAihe, Pos.CENTER);
	    Font font = new Font("Arial Bold", 18);
	    labelAihe.setFont(font);
	    labelAihe.setPadding(new Insets(10, 10, 0, 10));
	    pane.setTop(labelAihe);
	    
	    Button buttonAanesta = new Button("Äänestä"); 
        BorderPane.setAlignment(buttonAanesta, Pos.CENTER);
        BorderPane.setMargin(buttonAanesta, new Insets(0, 0, 20, 0));
	    pane.setBottom(buttonAanesta);
	    buttonAanesta.setDefaultButton(true);

	    VBox vbox = new VBox();
        pane.setCenter(vbox);
        BorderPane.setMargin(vbox, new Insets(20, 0, 0, 0));
	    
	    labelValittu = new Label("Valittu: Kyllä");
	    labelValittu.setMaxWidth(1000);
	    labelValittu.setAlignment(Pos.CENTER);
	    vbox.getChildren().add(labelValittu);
        
	    valinta = new RadioButtonChooser();
	    vbox.getChildren().add(valinta);
 
        valinta.setRivit(new String[] {"_Kyllä", "_Ei", "En _osaa sanoa"});
        // valinta.setSelectedIndex(0);

	    
        buttonAanesta.setOnAction( (e) -> handleAanesta() );
	    
	    initialize();
	    return pane;
	}
	
	private RadioButtonChooser valinta;
    private Label labelValittu;

    void handleAanesta() {
       aanesta();
    }
    

    private void initialize() {
        valinta.addSelectionListener((e) -> nayta());
        labelValittu.setText("");
    }
    
    
    private void nayta() {
        String s = valinta.getSelectedText();
        if ( s == null ) return;
        labelValittu.setText("Valittu: " + s);
    }


    private void aanesta() {
        String kohde = valinta.getSelectedText();
        int i = valinta.getSelectedIndex();
        Dialogs.showMessageDialog("Äänestit siis: " + kohde + " " + i);
    }
	
    
    /**
     * Luokka joka tekee monta RadioButtonia.  Tässä luodaan myös ScrollPane
     * valintajouokon ympärille ja laitetaan valmiiksi teksti Valitse.
     * Tämä voi olla liian specifistä ja tämä ominaisuus on jätetty pois
     * FGGuin vastaavasta komponetista ja tehty erikseen ScrollBorder johon
     * yhdistämällä saadaan tämä ominaisuus.
     * @author vesal
     * @version 6.2.2017
     *
     */
    public static class RadioButtonChooser extends VBox {
        private ToggleGroup groupAanestys;
        private VBox vbox3;
        private String rivit = "";

        /**
         * Alustetaan tila radiobuttoneille
         */
        public RadioButtonChooser() {
            this.setPadding(new Insets(10, 10, 10, 10));
            VBox.setMargin(this, new Insets(5, 20, 20, 20));
            this.setStyle("-fx-border-color: black;");

            Label labelValitse = new Label("Valitse:");
            this.getChildren().add(labelValitse);

            ScrollPane sp = new ScrollPane();
            sp.getStyleClass().add("edge-to-edge");
            this.getChildren().add(sp);
            
            vbox3 = new VBox();
            sp.setContent(vbox3);
            vbox3.setSpacing(15.0);
            vbox3.setPadding(new Insets(10, 0, 10, 20));
            
            groupAanestys = new ToggleGroup();
        }

        
        /**
         * @param listener kuuntelija muutokselle
         */
        public void addSelectionListener(InvalidationListener listener) {
            groupAanestys.selectedToggleProperty().addListener(listener);
        }


        /**
         * Asetetaan i's komponentti valituksi.
         * @param i mikä indeksi valituksi
         */
        public void setSelectedIndex(int i) {
            ObservableList<Toggle> rbs = groupAanestys.getToggles();
            if ( rbs.size() <= i ) return;
            groupAanestys.selectToggle(rbs.get(i));
        }


        /**
         * Asetetaan valittavat kohteet
         * @param kohteet taulukko kohteista
         */
        public void setRivit(String[] kohteet) {
            vbox3.getChildren().clear();
            this.rivit = String.join("\n", kohteet);
            groupAanestys.getToggles().clear();
            for (int i=0; i<kohteet.length; i++) {
                RadioButton rb = new RadioButton(kohteet[i]);
                vbox3.getChildren().add(rb);
                rb.setToggleGroup(groupAanestys);
                rb.setId("rb"+i);
                rb.setMnemonicParsing(true);
            }
        }

        
        /**
         * Asetetaan valittavat kohteet
         * @param rivit jono kohteista \n eriteltynä
         */
        public void setRivit(String rivit) {
            String[] kohteet = rivit.split("\n");
            setRivit(kohteet);
        }
        
        
        /**
         * @return kohteet \n eroteltuna
         */
        public String getRivit() {
            return this.rivit;
        }
                
        
        /**
         * Poistetaan alleviiva
         * @param item mistä poistetaan
         * @return ilman 1. alleviivaa
         */
        public static String removeMnemonic(String item) {
            return item.replaceFirst("_", "");
        }
        

        /**
         * @return valitun indeksi, -1 jos ei valittua
         */
        public int getSelectedIndex() {
            RadioButton rb = (RadioButton)groupAanestys.getSelectedToggle();
            if ( rb == null ) return -1;
            String id = rb.getId();
            return Integer.parseInt(id.substring(2));
        }


        /**
         * @return valittu teksti
         */
        public String getSelectedText() {
            RadioButton rb = (RadioButton)groupAanestys.getSelectedToggle();
            if ( rb == null ) return "";
            return removeMnemonic(rb.getText());
        }
    }
	
}
