package astia1;

/**
 *  Luokka ja ohjelma yksinkertaisessa muodossa.
 *  Katso kehitys: astia.Astia.java 
 *<br>
 *  Pelillä demonstroidaan/harjoitellaan miten voidaan kahdella astialla,
 *  5 l ja 8 l,  muodostaa kaikki mahdolliset tilavuudet 1-13 l.
 *  Pelissä on kaksi varsinaista astiaa: a5 ja a8, sekä kolmas apuastia
 *  ampari.  Nestettä voidaan kerrallaan kaataa yhdestä astiasta toiseen
 *  joko siten, että astian koko sisältö tyhjennetään jos se mahtuu
 *  tai astista kaadetaan sen verran että toinen astia tulee täyteen.
 *
 * @author  Vesa Lappalainen
 * @version 1.0, 09.02.2003
 */
public class Astia {
    private double tilavuus;
    private double maara;


    /**
     * Alustaa uuden astian tietyn kokoiseksi ja luonnollisetsi tyhjäksi
     * @param tilavuus uuden astian tilavuus
     * @example
     * <pre name="test">
     *  Astia a = new Astia(8);
     *  a.getMaara() ~~~ 0;
     * </pre>
     */
    public Astia(double tilavuus) {
        this.tilavuus = tilavuus;
        this.maara = 0;
    }


    /**
     * Täyttää astian piripintaan asti
     * @example
     * <pre name="test">
     *  Astia a = new Astia(8);
     *  a.getMaara() ~~~ 0;
     *  a.tayta();
     *  a.getMaara() ~~~ 8;
     * </pre>
     */
    public void tayta() {
        maara = tilavuus;
    }


    /**
     * Kaataa tästä astiasta (this) toiseen astiaan niin paljon kuin toiseen
     * mahtuu tai tästä astiasta on antaa.
     * @param astia astia johon kaadetaan
     * <pre name="test">
     *  Astia a8 = new Astia(8);
     *  Astia a5 = new Astia(5);
     *  a8.tayta();
     *  a8.kaada(a5);
     *  a5.getMaara() ~~~ 5;
     *  a8.getMaara() ~~~ 3;
     * </pre>
     */
    public void kaada(Astia astia) {
        double siirrettava = astia.tilavuus - astia.maara;
        if (maara < siirrettava)
            siirrettava = maara;
        astia.maara += siirrettava;
        maara -= siirrettava;
    }


    /**
     * @return astiassa olevan nesteen määrä
     * @example
     * <pre name="test">
     *  Astia a = new Astia(8);
     *  a.getMaara() ~~~ 0;
     * </pre>
     */
    public double getMaara() {
        return maara;
    }


    /**
     * Malliksi pari astiaa,joiden välillä kaadetaan
     * @param args ei käytössä
     */
    public static void main(String[] args) {
        Astia astia5l = new Astia(5);
        Astia astia8l = new Astia(8);
        Astia ampari = new Astia(100);

        ampari.tayta();

        ampari.kaada(astia8l);
        astia8l.kaada(astia5l);

        System.out.println("8 litran astiassa on " + astia8l.getMaara()
                + " litraa nestettä");
    }

}