package guiMalli2Kerho;

import java.io.PrintStream;

import javax.swing.JOptionPane;

import fi.jyu.mit.gui.TextAreaOutputStream;
import kerho.SailoException;
import kerho.*;

/**
 *
 * @author vesal
 * @version 24.2.2011
 */
public class KerhoSwing {
    private final Kerho kerho;
    private final KerhoGUI kerhoGUI;

    
    /**
     * Alustaa luokan niin, että se voi käyttää  Swing-komponentteja
     * @param kerhoGUI gui johon voi kirjoitella
     */
    public KerhoSwing(KerhoGUI kerhoGUI) {
        kerho = new Kerho();
        this.kerhoGUI = kerhoGUI;
    }

    
    /**
     * Lisätään uusi jäsen
     */
    public void uusiJasen() {
        try {
            Jasen jasen = new Jasen();
            jasen.rekisteroi();
            jasen.vastaaAkuAnkka();
            kerho.lisaa(jasen);
            kerhoGUI.getTextJasen().setText("");
            try (PrintStream os = TextAreaOutputStream.getTextPrintStream(kerhoGUI.getTextJasen()) ) {
              tulosta(os,jasen);
            }
        } catch (SailoException e) {
            JOptionPane.showMessageDialog(null, "Lisääminen ei onnistu");
        }
        
    }

    
    
    /**
     * Tulostaa jäsenen tiedot
     * @param os tietovirta johon tulostetaan
     * @param jasen tulostettava jäsen
     */
    public void tulosta(PrintStream os, final Jasen jasen) {
        os.println("----------------------------------------------");
        jasen.tulosta(os);
        os.println("----------------------------------------------");
    }


    /**
     * Tulostaa kaikki jäsenet
     */
    public void tulostaJasenet() {
        kerhoGUI.getTextJasenet().setText("");
        try ( PrintStream os = TextAreaOutputStream.getTextPrintStream(kerhoGUI.getTextJasenet()) ) {
            for (int i=0; i<kerho.getJasenia(); i++) {
                Jasen jasen = kerho.annaJasen(i);
                tulosta(os,jasen);
            }
        }
    }
    
    
}