package guiMalliKerho;

import java.io.PrintStream;

import javax.swing.JOptionPane;
import javax.swing.JTextArea;

import fi.jyu.mit.gui.TextAreaOutputStream;
import kerho.SailoException;
import kerho.*;

/**
 *
 * @author vesal
 * @version 24.2.2011
 */
public class KerhoSwing {
    private final Kerho            kerho;
    private JTextArea textJasen;
    private JTextArea textJasenet;
    
    
    /**
     * @return the textJasen
     */
    public JTextArea getTextJasen() {
        return textJasen;
    }

    
    /**
     * @param textJasen the textJasen to set
     */
    public void setTextJasen(JTextArea textJasen) {
        this.textJasen = textJasen;
    }

    
    /**
     * @return the textJasenet
     */
    public JTextArea getTextJasenet() {
        return textJasenet;
    }

    
    /**
     * @param textJasenet the textJasenet to set
     */
    public void setTextJasenet(JTextArea textJasenet) {
        this.textJasenet = textJasenet;
    }

    
    /**
     * Alustaa luokan niin, että se voi käyttää  Swing-komponentteja
     */
    public KerhoSwing() {
        kerho = new Kerho();
    }

    
    /**
     * Lisätään uusi jäsen
     */
    public void uusiJasen() {
        try {
            Jasen jasen = new Jasen();
            jasen.rekisteroi();
            jasen.vastaaAkuAnkka();
            kerho.lisaa(jasen);
            textJasen.setText("");
            try (PrintStream os = TextAreaOutputStream.getTextPrintStream(textJasen) ) {
              tulosta(os,jasen);
            }
        } catch (SailoException e) {
            JOptionPane.showMessageDialog(null, "Lisääminen ei onnistu");
        }
        
    }

    
    
    /**
     * Tulostaa jäsenen tiedot
     * @param os tietovirta johon tulostetaan
     * @param jasen tulostettava jäsen
     */
    public void tulosta(PrintStream os, final Jasen jasen) {
        os.println("----------------------------------------------");
        jasen.tulosta(os);
        os.println("----------------------------------------------");
    }

    

    /**
     * Tulostaa kaikki jäsenet
     */
    public void tulostaJasenet() {
        textJasenet.setText("");
        try ( PrintStream os = TextAreaOutputStream.getTextPrintStream(textJasenet) ) {
            for (int i=0; i<kerho.getJasenia(); i++) {
                Jasen jasen = kerho.annaJasen(i);
                tulosta(os,jasen);
            }
        }
    }
    
    
}