/**
 * @file kuut.c
 * Esimerkki taulukkojen kytst
 *
 * @author Vesa Lappalainen
 * @version 27.4.2003
 */
#include <stdlib.h>
#include <stdio.h>


/**
 * Summataan taulukon kaikki alkiot
 * @param lkm taulukon alkioiden lkm
 * @param taulu taulukko jonka alkiot summataan
 * @return alkioden summa
 * @code
 * <pre name="test">
 *   int t[] = {1,2,3,4};
 *   taulukon_summa(4,t) === 10;
 * </pre>
 * @endcode */
int taulukon_summa(int lkm, int taulu[])
{
   int i;
   int summa = 0;
   for (i=0; i<lkm; i++)
       summa += taulu[i];
   return summa;
}


int kuutTestOrigMain(void)
{
                    /*  1. 2. 3. 4. 5. 6. 7. 8. 9.10.11.12 */
  int k_pituudet[12] = {31,28,31,30,31,30,31,31,30,31,30,31};
  int *tammikuu,*helmikuu,*joulukuu,*p,i;


  printf("Vuodessa on pivi %d.\n",taulukon_summa(12,k_pituudet));


  for (i=0; i<12; i++) k_pituudet[i]=0;
  tammikuu  = k_pituudet;
  helmikuu  = tammikuu+1;
  joulukuu  = k_pituudet+11;
  *tammikuu = 31;
  *helmikuu = 28;
  *joulukuu = 31;

  for (i=0, p=k_pituudet; i<12; i++, p++)
    *p=0;
  for (i=0, p=k_pituudet; i<12; i++)
    *p++=30;
  for (p=k_pituudet; p<k_pituudet+12; p++)
    *p=0;

  return 0;
}
#include <iostream>
#include <cstring>
namespace comtestCppNameSpace {
//#define assertEquals(s,e,g) { if ( comtestCppNameSpace::assertEqualsImpl((s),(e),(g)) ) return; }
//#define assertEqualsDelta(s,e,g,delta) { if ( comtestCppNameSpace::assertEqualsImpl((s),(e),(g),(delta)) ) return; }
#define assertEquals comtestCppNameSpace::assertEqualsImpl

template <class T1>
class assertion_traits {
  public: static bool equal( const T1& x, const T1& y ) {
    return x == y;
  }
};


template<>
class assertion_traits<const char *> {
  public: static bool equal( const char *x,const char *y) {
    if ( x == 0 && y == 0 ) return true;
    if ( x == 0 || y == 0 ) return false;
    return std::strcmp(x,y) == 0;
  }
};

template<>
class assertion_traits<char *> {
  public: static bool equal( const char *x,char *y) {
    if ( x == 0 && y == 0 ) return true;
    if ( x == 0 || y == 0 ) return false;
    return std::strcmp(x,y) == 0;
  }
};

template <class T1>
int assertEqualsImpl(const char *msg,const T1 &expected, const T1 &actual) {
if ( assertion_traits<T1>::equal(expected,actual) ) return 0;
std::cout << msg << ": expected [" << expected << "] actual [" << actual << "]" << std::endl;
throw int(1);
}

template <class T1>
int assertEqualsImpl(const char *msg,const char  *expected, const T1 &actual) {
if ( assertion_traits<T1>::equal(expected,actual) ) return 0;
if ( expected == 0 ) std::cout << msg << ": expected [null] actual [" << actual << "]" << std::endl;
else if ( &actual == 0 ) std::cout << msg << ": expected [" << expected << "] actual [null]" << std::endl;
else std::cout << msg << ": expected [" << expected << "] actual [" << actual << "]" << std::endl;
throw int(1);
}

int assertEqualsImpl(const char *msg,int expected, int actual) {
if ( expected == actual ) return 0;
std::cout << msg << ": expected [" << expected << "] actual [" << actual << "]" << std::endl;
throw int(1);
}

int assertEqualsImpl(const char *msg,long expected, long actual) {
if ( expected == actual ) return 0;
std::cout << msg << ": expected [" << expected << "] actual [" << actual << "]" << std::endl;
throw int(1);
}


int assertEqualsImpl(const char *msg,double expected, double actual, double delta) {
if ( -delta <= (actual-expected) && (actual-expected) <= delta ) return 0;
std::cout << msg << ": expected [" << expected << "] actual [" << actual << "]" << std::endl;
throw int(1);
}

}

/**
 * Test class made by ComTest
 * @version 2014.04.19 21:52:26 // Generated by ComTest
 *
 */
class kuutTest {


  // Generated by ComTest BEGIN
  /** testTaulukon_summa18 */
  public: void testTaulukon_summa18() {    // kuut: 18
    int t[] = { 1,2,3,4} ; 
    assertEquals("From: kuut line: 20", 10, taulukon_summa(4,t)); 
  } // Generated by ComTest END

  int runner(void) {
      int errors = 0;
      try { testTaulukon_summa18(); } catch (...) { errors++; }
      if ( errors == 0 ) std::cout << "ok" << std::endl;
      return errors;
  }

};

int main(void) {
    kuutTest t; t.runner();
    return 0;
}
